import { AfterViewInit, DoCheck, ElementRef, EventEmitter, KeyValueDiffers, NgZone, OnDestroy } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { Editor, EditorChange, EditorFromTextArea, ScrollInfo } from 'codemirror';
import * as i0 from "@angular/core";
export declare class CodemirrorEditorDirective implements AfterViewInit, OnDestroy, ControlValueAccessor, DoCheck {
    private textArea;
    private _differs;
    private _ngZone;
    className: string;
    name: string;
    autoFocus: boolean;
    /**
     * set options for codemirror
     * @link http://codemirror.net/doc/manual.html#config
     */
    set options(value: {
        [key: string]: any;
    });
    preserveScrollPosition: boolean;
    enableAutoComplete: boolean;
    autoCompleteWords: string[];
    usePreviousWords: boolean;
    cursorActivity: EventEmitter<Editor>;
    focusChange: EventEmitter<boolean>;
    scroll: EventEmitter<ScrollInfo>;
    drop: EventEmitter<[Editor, DragEvent]>;
    changeValue: EventEmitter<any>;
    value: string;
    disabled: boolean;
    isFocused: boolean;
    codeMirror?: EditorFromTextArea;
    /**
     * either global variable or required library
     */
    private _codeMirror;
    private _differ?;
    private _options;
    constructor(textArea: ElementRef, _differs: KeyValueDiffers, _ngZone: NgZone);
    get codeMirrorGlobal(): any;
    ngAfterViewInit(): void;
    ngDoCheck(): void;
    ngOnDestroy(): void;
    codemirrorValueChanged(cm: Editor, change: EditorChange): void;
    setOptionIfChanged(optionName: string, newValue: any): void;
    focusChanged(focused: boolean): void;
    scrollChanged(cm: Editor): void;
    cursorActive(cm: Editor): void;
    dropFiles(cm: Editor, e: DragEvent): void;
    /** Implemented as part of ControlValueAccessor. */
    writeValue(value: string): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnChange(fn: (value: string) => void): void;
    /** Implemented as part of ControlValueAccessor. */
    registerOnTouched(fn: () => void): void;
    /** Implemented as part of ControlValueAccessor. */
    setDisabledState(isDisabled: boolean): void;
    /** Implemented as part of ControlValueAccessor. */
    onChange: (_: any) => void;
    /** Implemented as part of ControlValueAccessor. */
    private onTouched;
    registerAutoComplete(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CodemirrorEditorDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<CodemirrorEditorDirective, "[codemirrorEditor]", never, { "className": "className"; "name": "name"; "autoFocus": "autoFocus"; "options": "options"; "preserveScrollPosition": "preserveScrollPosition"; "enableAutoComplete": "enableAutoComplete"; "autoCompleteWords": "autoCompleteWords"; "usePreviousWords": "usePreviousWords"; }, { "cursorActivity": "cursorActivity"; "focusChange": "focusChange"; "scroll": "scroll"; "drop": "drop"; "changeValue": "changeValue"; }, never>;
}
